/**
 * BubbleSortExample.java
 * 
 * Time-stamp: <2010-04-13 15:23:37 ftaiani>
 * @author Francois Taiani   <francois.taiani@comp.lancs.ac.uk>
 * $Id$
 * 
 */

package bubbleSort;

import java.util.*;
import java.io.*;

/**
 * @author Francois Taiani   <francois.taiani@comp.lancs.ac.uk>
 */
public class BubbleSortExample {

    List<String>  myList   = new ArrayList<String>();
    bubbleSort.sorter.Sorter mySorter = new bubbleSort.sorter.Sorter();
    
    public BubbleSortExample() throws Exception {
//         String[] data = {"The", "red", "fox", "jumps", "over", 
//                          "the", "blue", "fence"};
//         for(int i=0 ; i < data.length; i++) {
//             myList.add(data[i]);
//         } // EndFor
        readFile("Frankenstein-words.txt");
    } // EndConstructor BubbleSortExample

    private void readFile(String fileName) throws Exception {
        BufferedReader br = 
            new BufferedReader
            ( new InputStreamReader
              ( new DataInputStream
                ( new FileInputStream(fileName)) ) );
        String strLine;
        
        int count = 1500; // max number of words

        while ((strLine = br.readLine()) != null && count>0) {
            strLine.trim();
            if (strLine.length()>0) {
                myList.add(strLine.toLowerCase());
                count--;
            }
        } // EndWhile
    } // EndMethod readFile


    private void printMyListOfString() {
        for(int i=0 ; i < myList.size(); i++) {
            System.out.println(myList.get(i)+" ("+i+")");
        } // EndFor
    } // EndMethod printMyListOfString

    public void runExample() {
        mySorter.sortListOfString(myList);
        printMyListOfString();
    } // EndMethod runExample

    static public void main(String[] args) throws Exception {
        new BubbleSortExample().runExample();
    } // EndMain

} // EndClass BubbleSortExample
