/**
 * Spring.java
 * 
 * Time-stamp: <2010-04-05 16:50:07 ftaiani>
 * @author Francois Taiani   <francois.taiani@comp.lancs.ac.uk>
 * $Id$
 * 
 */

package simulation.universe;

/**
 * @author Francois Taiani   <francois.taiani@comp.lancs.ac.uk>
 * Simulates a spring attached to 2 nodes
 */
public class Spring {

    public Node node1, node2;
    double idealLength ;

    public Spring(Node aNode1, Node aNode2, double someIdealLength) {
        node1 = aNode1 ;
        node2 = aNode2 ;
        idealLength = someIdealLength ;
    } // EndConstructor Spring

    public Force getForce() {
        double deltaX = node2.x - node1.x ;
        double deltaY = node2.y - node1.y ;
        
        double length = Math.sqrt(deltaX*deltaX + deltaY*deltaY);
        double ratio  = 1.0 - idealLength/length;
        Force result = new Force(deltaX*ratio, deltaY*ratio);
        return result;
    } // EndMethod getForce


    public void computeForce() {
        Force f = getForce();
        // System.out.println("Force: "+f.x+","+f.y);
        node1.force.addForce(f);
        node2.force.addForce(f.reverseForce());
    } // EndMethod computeForce

} // EndClass Spring
