/**
 * simpleVisualiser.java
 * 
 * Time-stamp: <2010-04-05 17:14:46 ftaiani>
 * @author Francois Taiani   <francois.taiani@comp.lancs.ac.uk>
 * $Id$
 * 
 */

package simulation.visu;

import processing.core.*;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.*;

import simulation.simulator.*;
import simulation.universe.* ;

/**
 * @author Francois Taiani   <francois.taiani@comp.lancs.ac.uk>
 */
public class SimpleVisualiser extends PApplet {

    Engine myEngine ;
    int count = 300 ;

    public void setup() {
        Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
	int screenWidth  = (int) dimension.getWidth ();
	int screenHeight = (int) dimension.getHeight();
        
        noStroke();
        size(screenWidth, screenHeight);
        
        myEngine = new Engine(200,screenWidth, screenHeight);
    } // EndMethod setup

    public void draw() {
        background(60);
        int i = 0;
        for (Iterator<Node> iter = myEngine.getNodeIterator(); iter.hasNext() ;) {
            i++;
            fill(i%256,(i+128)%256,255-(i%256),192);
            Node currNode = iter.next();
            ellipse((float)currNode.x,(float)currNode.y,60.0f,60.0f);
        } // EndFor
        myEngine.updateSimulationStep(0.02);
        count--;
        if (count<=0) exit() ;
        //        exit();
    } // EndMethod draw

    public static void main(String args[]) {
        PApplet.main(new String[] { "--present", "simulation.visu.SimpleVisualiser" });
    } // EndMain

} // EndClass SimpleVisualiser
