/**
 * The entry point of the visualisation tool.
 * 
 * @author Shen Lin
 */

package src;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class ApplicationFrame {
	
	public static void main(String[] args) {

		// Create the main frame of the visualisation tool.
		JFrame frame = new JFrame("Visualisation Tool");
		Container container = frame.getContentPane();
		container.setLayout(new BorderLayout());
		
		// Create the main graph of the profiling information.
		GraphicPanel applet = new GraphicPanel();
		applet.init();
		
		// Add the graphics to the main frame.
		JPanel graphicPanel = new JPanel();
		graphicPanel.add(applet);
		container.add(graphicPanel, BorderLayout.CENTER);
		
		// Add the control panel.
		ControlPanel controlPanel = new ControlPanel(applet);
		container.add(controlPanel, BorderLayout.EAST);
		
		// Set window close, frame size, and visibility.
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		frame.setSize(dim.width, dim.height);
		frame.pack();
		frame.setVisible(true);
	}
}
