package src;

import java.util.ArrayList;

import processing.core.*;

public class ColorDistribution {

	ArrayList<int[]> colors;
	
	public ColorDistribution() {
		this.colors = new ArrayList<int[]>();
	}
	
	public ArrayList<int[]> distribute(int n, int x_before, int x_after, 
			                int y_before, int y_after,
			                int z_before, int z_after) {
		this.colors = new ArrayList<int[]>();
		int scale = findScale(n);
		int x_unit = (x_after - x_before) / scale;
		int y_unit = (y_after - y_before) / scale;
		int z_unit = (z_after - z_before) / scale;
		
		for (int i = 0; i < scale; i++) {
			for (int j = 0; j < scale; j++) {
				for (int k = 0; k < scale; k++) {
					int r = x_before + (x_unit / 2) + i * x_unit;
					int g = y_before + (y_unit / 2) + j * y_unit;
					int b = z_before + (z_unit / 2) + k * z_unit;
					int[] color = {r, g, b, x_unit/2, y_unit/2, z_unit/2};
					colors.add(color);
				}
			}
		}
		return colors;
	}
	
	public int findScale(int n) {
		for (int i = 1; i < Integer.MAX_VALUE - 1; i++) {
			if (Math.pow(i, 3) < n && Math.pow(i + 1, 3) > n) {
				return i + 1;
			} else if (Math.pow(i, 3) == n) {
				return i;
			}
		}
		return -1;
	}
}
