package src;

import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


public class ControlPanel extends JPanel implements ActionListener, MouseListener, ChangeListener {

	public GraphicPanel applet;

	public JButton leftButton = new JButton("Left");
	public JButton rightButton = new JButton("Right");
	public JButton upButton = new JButton("Up");
	public JButton downButton = new JButton("Down");

	public int MIN_LEVEL = 0;
	public int MAX_LEVEL = 10;
	/** The detail level of profiling data */
	public JSlider detailLevelSlider = new JSlider(JSlider.HORIZONTAL,
			                            MIN_LEVEL, 
			                            MAX_LEVEL,
                                        MIN_LEVEL);
	
	public String[] ComboBoxChoices = {"Package Type", "Frequency", "Process Time"};
	public JComboBox themeSelection = new JComboBox(ComboBoxChoices);

	public ControlPanel(GraphicPanel applet) {
		super();
		this.applet = (GraphicPanel)applet;

		this.setLayout(new GridLayout(3, 1));
		// constructs the Move button panel
		JPanel movePanel = new JPanel();
		movePanel.setLayout(new GridLayout(3, 3));
		movePanel.add(new JPanel());
		movePanel.add(upButton);
		movePanel.add(new JPanel());
		movePanel.add(leftButton);
		movePanel.add(new JPanel());
		movePanel.add(rightButton);
		movePanel.add(new JPanel());
		movePanel.add(downButton);
		movePanel.add(new JPanel());

		upButton.addMouseListener(this);
		downButton.addMouseListener(this);
		leftButton.addMouseListener(this);
		rightButton.addMouseListener(this);
		this.add(movePanel);
		
		// configure the slider
		detailLevelSlider.setMajorTickSpacing(5);
		detailLevelSlider.setMinorTickSpacing(1);
		detailLevelSlider.setPaintTicks(true);
		detailLevelSlider.setPaintLabels(true);
		detailLevelSlider.addChangeListener(this);
		
		// constructs the slider panel that adjusts the graphic settings
		JPanel sliderPanel = new JPanel();
		sliderPanel.setLayout(new FlowLayout());
		sliderPanel.add(new JLabel("Detail Level: "));
		sliderPanel.add(detailLevelSlider);
		this.add(sliderPanel);
		
		// constructs the combo box panel
		JPanel comboPanel = new JPanel();
		comboPanel.setLayout(new FlowLayout());
		comboPanel.add(new JLabel("Theme: "));
		comboPanel.add(themeSelection);
		this.add(comboPanel);
	}

	public void mousePressed(MouseEvent me) {
		if (me.getSource() instanceof JButton) {
			JButton button = (JButton)me.getSource();
			//applet.move(button.getActionCommand());
		}
	}
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
	
	public void stateChanged(ChangeEvent ce) {
		
	}

	public void actionPerformed(ActionEvent ae) {
		
	}
}
