package src;

import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

public class LogGenerator {
	
	public String fileName;
	public boolean enable;
	public boolean mouseEntered = false;
	
	public LogGenerator(String fileName, boolean enable) {
		if (enable) System.out.println(fileName + " " + enable );
		this.fileName = fileName;
		this.enable = enable;
	}
	
	public String getBranchPath(VisNode node) {
		String result = "";
		
		ArrayList<String> backwardPath = new ArrayList<String>();
		backwardPath.add(node.packageName);
		VisNode currentNode = node;
		while (currentNode.parent != null) {
			backwardPath.add(currentNode.parent.packageName);
			currentNode = currentNode.parent;
		}
		
		for (int i = backwardPath.size() - 1; i >= 0; i--) {
			result += backwardPath.get(i) + "/";
		}
		return result;
	}
	
	public void log(String info) {
		if (enable && GraphicPanel.Tutorial == 1) {
			//DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
			//Date date = new Date();
			//String timeInfo = dateFormat.format(date);

			long timeInfo = System.currentTimeMillis();
			try {
				FileWriter fw = new FileWriter(fileName, true);
				fw.append(info + ";Time:" + timeInfo + "\n");
				fw.flush();
				fw.close();
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
