package src;

public class PackageNameFormatter {

	/**
	 * This method generates an abbrievation of the orignal string to fit into
	 * a text area with constraint width and height
	 * @param packageName original package name
	 * @param colMax maximum number of letters allowed in a row
	 * @param rowMax maximum number of letters allowed in a column
	 * @return formatted package name
	 */
	public static String[] formatPackageName(String packageName, int colMax, int rowMax) {
		int totalMax = colMax * rowMax;
		String[] result = new String[rowMax];
		
		if (packageName.length() > totalMax) {
			String prefix = packageName.substring(0, totalMax / 2 - 1);
			String postfix = packageName.substring(packageName.length() - totalMax / 2 + 2, packageName.length());
			packageName = prefix + "..." + postfix;
		}
		
		String tmp = "";
		int index = 0;
                int nextBreak=colMax;
		for (int i = 0; i < packageName.length(); i++) {
			tmp = tmp + packageName.charAt(i);
			if (i != 0 && packageName.charAt(i)=='.' && i >= nextBreak - 1) {
				result[index] = tmp;
				index++;
				tmp = "";
                                nextBreak = i + colMax;
			}
			else if (i == packageName.length() - 1) {
				result[index] = tmp;
			}
		}
		return result;
	}
	
	public static void main(String[] args) {
		String packageName = "org.apache.axis.wsdl.symbolTable.setTypeReferences";
		System.out.println(packageName);
		System.out.println();
		String[] result = formatPackageName(packageName, 16, 2);
		for (int i = 0; i < result.length; i++) {
			System.out.println(result[i]);
		}
	}
}
