/* -*-  Mode:Java; c-basic-offset:2; tab-width:2; indent-tabs-mode:1; -*- */

package src;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.StringTokenizer;

import processing.core.PConstants;
import processing.core.PFont;

public class TreeLayout extends Display {
	
	public int FONT_SIZE = 10;

	public TreeLayout(VisNode visTree, GraphicPanel graphicPanel) {
		super(visTree, graphicPanel,20);
	}
	
	public VisNode display(VisNode root, int mouseX, int mouseY, VisNode nodeUnderMouse){
		this.graphicPanel.background(graphicPanel.getBackgroundColour());
		if (!this.graphicPanel.animationLock) {
			this.structureAggregation(root);
			this.recursiveRelocation(root);
		}
		return this.recursiveDisplay(root, mouseX, mouseY, nodeUnderMouse);
	}

	public int structureAggregation(VisNode node) {
		if (node.children.size() == 0 || !node.expanded) {
			node.widthFactor = 1;
			return 1;
		}
		else {
			int totalWidth = 0;
			for(VisNode nextNode: node.children) {
				//			for(int i = 0; i < node.children.size(); i++) {
				totalWidth += structureAggregation(nextNode);
			}
			node.widthFactor = totalWidth;
			return totalWidth;
		}
	}

	// [CHANGE] FT05Apr11: refactored to Display

// 	public VisNode getClickedNode(VisNode visNode, int mouseX, int mouseY) {
// 		// --- 2010 code
// 		int newHalfWidth = HALF_WIDTH;
// 		int newHalfHeight = HALF_HEIGHT;
// 		if (visNode.profile > 0) {
// 			double scaleVar = this.getScaleVar(visNode, this.maxFrequency);
// 			newHalfWidth  = (int)(HALF_WIDTH / scaleVar);
// 			newHalfHeight = (int)(HALF_HEIGHT / scaleVar);
// 		}

// 		// ---
// 		boolean contains = contains(visNode.x, visNode.y, mouseX, mouseY, newHalfWidth, newHalfHeight);
// 		if (contains) {
// 			return visNode;
// 		}
// 		else {
// 			for(VisNode childNode: visNode.children) {
// // 			for (int i = 0; i < visNode.children.size(); i++) {
// // 				VisNode childNode = visNode.children.get(i);
// 				VisNode clickedNode = getClickedNode(childNode, mouseX, mouseY);
// 				if (clickedNode != null) {
// 					return clickedNode;
// 				}
// 			}
// 		}
// 		return null;
// 	}
	
// 	public boolean contains(int x1, int y1, int x2, int y2, int HALF_WIDTH, int HALF_HEIGHT) {

// 		return (x2 >= x1 - HALF_WIDTH && y2 <= y1 + HALF_HEIGHT)
// 		       && (x2 <= x1 + HALF_WIDTH && y2 >= y1 - HALF_HEIGHT);
		
// 	}
	

	/**
	 * Calculates the new location of the nodes 
	 * @param node
	 */
	public void recursiveRelocation(VisNode node) {
		if (node.expanded) {
			int accumulatedFactor = 0;
// 			for (int i = 0; i < node.children.size(); i++) {
// 				VisNode visChild = node.children.get(i);
			for(VisNode visChild: node.children) {
				int parentWidthFactor = node.widthFactor;
				int nextWidthFactor = visChild.widthFactor;

				double locationScale = accumulatedFactor + (((double)nextWidthFactor) / 2.0);
				double midScale = ((double)parentWidthFactor) / 2.0;
				float childLocX = node.x + (int)((locationScale - midScale) * ((double)H_SPACE));
				float childLocY = node.y + V_SPACE;;	
			
				visChild.setLocation(childLocX, childLocY);
				recursiveRelocation(visChild);		
				accumulatedFactor += nextWidthFactor;
			}
		}
	}
		
// 	/**********************************************
// 	 * Start of animation computation
// 	 **********************************************/
	
// 	public void addMovementRecord(VisNode lowNode, VisNode highNode, Hashtable<VisNode, int[]> movementRecords, boolean moveUp) {
// 		if (!lowNode.packageName.equals("Null")) {
// 			// movement record
// 			if (moveUp) {
// 				int[] movedLoc = new int[2];
// 				movedLoc[0] = highNode.x;
// 				movedLoc[1] = highNode.y;
// 				movementRecords.put(lowNode, movedLoc);
				
// 			} else {
// 				int[] movedLoc = new int[2];
// 				movedLoc[0] = lowNode.x;
// 				movedLoc[1] = lowNode.y;
// 				lowNode.x = highNode.x;
// 				lowNode.y = highNode.y;
// 				if (!movementRecords.containsKey(lowNode)) {
// 					movementRecords.put(lowNode, movedLoc);
// 				}
// 			}
// 		}

// 	}
	
// 	public int branchPatternMatch(ArrayList<VisNode> nextLowBranch, ArrayList<VisNode> nextHighBranch) {
// 		int highIndex = nextHighBranch.size() - 1;
// 		int lowIndex = nextLowBranch.size() - 1;

// 		boolean wasEqual = false;

// 		while (highIndex >= 0 && lowIndex >= 0) {
// 			VisNode nextHighNode = nextHighBranch.get(highIndex);
// 			VisNode nextLowNode = nextLowBranch.get(lowIndex);
// 			String highString = nextHighNode.packageName;
// 			String lowString = nextLowNode.packageName;
			
// 			if (this.movementMatch(highString, lowString)) {
// 				//System.out.println("Match " + highString + " " + lowString);
// 				lowIndex--;
// 				wasEqual = true;
// 			} else {
// 				//System.out.println("No match " + highString + " " + lowString);
// 				if (wasEqual) { wasEqual = false; highIndex--;} 
// 				else {return 0;}
// 			}
// 		}
		
// 		if (highIndex == 0 && lowIndex < 0) {
// 			return 1; // perfect match, highest priority
// 		} 
// 		else if (highIndex < 0 && lowIndex >= 0) {
// 			return 0; 
// 		}
// 		else { //if (highIndex >= 0 && lowIndex < 0)
// 			return 2;
// 		}
// 	}
	
// 	public void movementProcess(ArrayList<VisNode> nextLowBranch, 
// 			ArrayList<VisNode> nextHighBranch, 
// 			Hashtable<VisNode, int[]> movementRecords, 
// 			boolean moveUp) {
		
// 		int lowIndex = nextLowBranch.size() - 1;
// 		int highIndex = nextHighBranch.size() - 1;
// 		boolean wasEqual = false;
		
// 		while (lowIndex >= 0 && highIndex >= 0) {
// 			VisNode lowNode = nextLowBranch.get(lowIndex);
// 			VisNode highNode = nextHighBranch.get(highIndex);
// 			String lowString = lowNode.packageName;
// 			String highString = highNode.packageName;
			
// 			if (this.movementMatch(highString, lowString)) {
// 				lowIndex--;
// 				wasEqual = true;
// 				// add movement record
// 				this.addMovementRecord(lowNode, highNode, movementRecords, moveUp);
// 			}
// 			else {
// 				if (wasEqual) {
// 					wasEqual = false;
// 					highIndex--;
// 				}
// 			}
// 		}
// 	}
 	
	public Hashtable<VisNode, float[]> computeMoves(VisNode visRoot, VisNode futureRoot, boolean moveUp) {
		Hashtable<VisNode, float[]> movementRecords = new Hashtable<VisNode, float[]>();
		
		this.structureAggregation(futureRoot);
		this.recursiveRelocation(futureRoot);

		VisNode highLevelTree = null;
		VisNode lowLevelTree = null;
		if (moveUp) {
			highLevelTree = futureRoot;
			lowLevelTree = visRoot;
		} else {
			highLevelTree = visRoot;
			lowLevelTree = futureRoot;
		}
		
		ArrayList<ArrayList<VisNode>> lowLevelTreeBranches = this.graphicPanel.tree2Branches(lowLevelTree);
		ArrayList<ArrayList<VisNode>> highLevelTreeBranches = this.graphicPanel.tree2Branches(highLevelTree);
	
		for (int i = 0; i < lowLevelTreeBranches.size(); i++) {
			ArrayList<VisNode> nextLowBranch = lowLevelTreeBranches.get(i);
			
			ArrayList<ArrayList<VisNode>> MatchBranches_1 = new ArrayList<ArrayList<VisNode>>();
			ArrayList<ArrayList<VisNode>> MatchBranches_2 = new ArrayList<ArrayList<VisNode>>();
			
			boolean foundPerfectMatch = false;
			
			for (int j = 0; j < highLevelTreeBranches.size(); j++) {
				ArrayList<VisNode> nextHighBranch = highLevelTreeBranches.get(j);
				
				//System.out.println(nextLowBranch + "\n" + nextHighBranch + "\n\n");
				
				int result = branchPatternMatch(nextLowBranch, nextHighBranch);
				
				// find the perfect match
				if (result == 1) {
					foundPerfectMatch = true;
					MatchBranches_1.add(nextHighBranch);
				}
				else if (result == 2) {
					MatchBranches_2.add(nextHighBranch);
				}
			}
			
			if (!foundPerfectMatch) {
				//System.out.println("whats here " + MatchBranches_2);
				int index = leastAbstractMatch(MatchBranches_2);
				ArrayList<VisNode> nextHighBranch = MatchBranches_2.get(index);
				//System.out.println("selected match 1" + nextHighBranch);
				movementProcess(nextLowBranch, nextHighBranch, movementRecords,  moveUp);
			}
			else {
				//System.out.println("whats here " + MatchBranches_1);
				int index = leastAbstractMatch(MatchBranches_1);
				ArrayList<VisNode> nextHighBranch = MatchBranches_1.get(index);
				//System.out.println("selected match 2" + nextHighBranch);
				movementProcess(nextLowBranch, nextHighBranch, movementRecords,  moveUp);
			}
			//System.out.println("++++++++++++++++++");
		}
		
		if (moveUp) {
			// do nothing until animation finished
		} else {
			this.graphicPanel.visRoot = futureRoot;
		}
		return movementRecords;
	}
	
	
	/**********************************************
	 * End of animation computation
	 **********************************************/

// 	public void zoomin() {
// 		this.Scale = this.graphicPanel.SCALE;
// 		if (this.Scale >= 0.1) {
// 			this.myFont = this.graphicPanel.createFont("FFScala", (int) (ORIGIN_FONT_SIZE * Scale));
// 			H_SPACE = (int)((double)ORIGIN_H_SPACE * Scale);
// 			V_SPACE = (int)((double)ORIGIN_V_SPACE * Scale);

// 			WIDTH = (int)((double)ORIGIN_WIDTH * Scale);
// 			HEIGHT = (int)((double)ORIGIN_HEIGHT * Scale);
// 			HALF_WIDTH = WIDTH / 2;
// 			HALF_HEIGHT = HEIGHT / 2;

// 			RECT_HEIGHT = (int)((double)ORIGIN_RECT_HEIGHT * Scale);
// 			RECT_WIDTH = (int)((double)ORIGIN_RECT_WIDTH * Scale);

// 			PARENT_WIDTH = (int)((double)ORIGIN_PARENT_WIDTH * Scale);
// 			PARENT_HEIGHT = (int)((double)ORIGIN_PARENT_HEIGHT * Scale);
// 			CIRCLE_ARROW_RADIUS = (int)((double)ORIGIN_CIRCLE_ARROW_RADIUS * Scale);
// 		}
// 	}

// 	public void zoomout() {
// 		this.Scale = this.graphicPanel.SCALE;
// 		if (this.Scale <= 2.0) {
// 			this.myFont = this.graphicPanel.createFont("FFScala", (int) (ORIGIN_FONT_SIZE * Scale));
// 			H_SPACE = (int)((double)ORIGIN_H_SPACE * Scale);
// 			V_SPACE = (int)((double)ORIGIN_V_SPACE * Scale);

// 			WIDTH = (int)((double)ORIGIN_WIDTH * Scale);
// 			HEIGHT = (int)((double)ORIGIN_HEIGHT * Scale);
// 			HALF_WIDTH = WIDTH / 2;
// 			HALF_HEIGHT = HEIGHT / 2;

// 			RECT_HEIGHT = (int)((double)ORIGIN_RECT_HEIGHT * Scale);
// 			RECT_WIDTH = (int)((double)ORIGIN_RECT_WIDTH * Scale);

// 			PARENT_WIDTH = (int)((double)ORIGIN_PARENT_WIDTH * Scale);
// 			PARENT_HEIGHT = (int)((double)ORIGIN_PARENT_HEIGHT * Scale);
// 			CIRCLE_ARROW_RADIUS = (int)((double)ORIGIN_CIRCLE_ARROW_RADIUS * Scale);
// 		}
// 	}
} // EndClass TreeLayout
