package treetable;

import java.awt.Color;
import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.*;

public class GraphicBar extends DefaultTableCellRenderer {
	
    private final JProgressBar bar = new JProgressBar(0, 10000);
    //private final JProgressBar bar = new ProgressBar();
    private DataProcessor dataProcessor;
	
    public GraphicBar(DataProcessor someDataProcessor) {
        super();
        setOpaque(true);
        //        bar.setUI(new javax.swing.plaf.metal.MetalProgressBarUI()); 
        bar.setUI(new javax.swing.plaf.basic.BasicProgressBarUI());
        bar.setUI(new MyProgressBarUI());
        bar.setBorder(BorderFactory.createEmptyBorder(1, 1, 1, 1));
    	bar.setStringPainted(true);
        dataProcessor = someDataProcessor;
    }

    Color computeColor(float percentage) {
        float percent = (percentage/dataProcessor.maxPercent);
        int r, g;
        if (percent<50) {
            g = 255;
            r = (int)(percent*255.0/50.0);
        } else {
            r = 255;
            g = (int)((100-percent)*255.0/50.0);
        }
        return new Color(r,g,0);
    }
	
    public Component getTableCellRendererComponent(JTable table, Object value,
            boolean isSelected, boolean hasFocus, int row, int column) {
        
    	float percentage = (Float)value;
    	float result = percentage * 100;
    	bar.setValue((int)result);
    	
        // System.out.println(((Float)value).intValue());

    	bar.setForeground(computeColor(percentage));
        //        bar.setBackground(new Color(255,255,255));
        return bar;
    }
}

class MyProgressBarUI extends javax.swing.plaf.basic.BasicProgressBarUI {
    protected Color getSelectionForeground() {
        return Color.black ;
    }
        
    protected Color getSelectionBackground()  {
        return Color.black ;
    }
} // EndClass MyProgressBarUI
